明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 218|回复: 7

[提问] 求一个选取线段的代码

[复制链接]
发表于 2021-1-25 21:33 | 显示全部楼层 |阅读模式
5明经币
求一个选取线段的代码

框选,两端有相交或相连的不选,有一端或两端都没相交的选中。一般线段

谢谢了。
发表于 2021-1-25 21:33 | 显示全部楼层
  1. (defun c:tt ()
  2.   (setq        i   -1
  3.         ss1 (ssadd)
  4.   )
  5.   (if (setq ss (ssget '((0 . "*LINE,ARC"))))
  6.     (while (setq s1 (ssname ss (setq i (1+ i))))
  7.       (setq p1 (vlax-curve-getStartPoint s1)
  8.             p2 (vlax-curve-getEndPoint s1)
  9.       )
  10.       (if (or (= (sslength (ssget "c" p1 p1)) 1)
  11.               (= (sslength (ssget "c" p2 p2)) 1)
  12.           )
  13.         (ssadd s1 ss1)
  14.       )
  15.     )
  16.   )
  17.   (sssetfirst nil ss1)
  18.   (princ)
  19. )
回复

使用道具 举报

发表于 2021-1-26 14:49 | 显示全部楼层
xyp1964很厉害!这么快就出源码!!
(if (setq ss (ssget '((0 . "*LINE,ARC"))))这一句改为(if (setq ss (ssget '((0 . "*LINE,POLYLINE,ARC"))))更好。

点评

*LINE不包含POLYLINE?  发表于 2021-2-1 23:13
回复

使用道具 举报

发表于 2021-1-26 14:51 | 显示全部楼层
楼上的,怎么赶快把赏的5币给2楼xyp1964吧
回复

使用道具 举报

 楼主| 发表于 2021-1-26 22:38 | 显示全部楼层

太感谢了,不是每天都上,想不到回复那么快,谢谢了
回复

使用道具 举报

发表于 2021-1-28 14:39 | 显示全部楼层
选取这样的线段有什么用啊  ?
回复

使用道具 举报

发表于 2021-2-14 09:33 | 显示全部楼层
香远益清 发表于 2021-1-26 14:49
xyp1964很厉害!这么快就出源码!!
(if (setq ss (ssget '(( ...

是的,两个概念,互不包含。polyline是多义线。
回复

使用道具 举报

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2020 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2021-3-3 23:09 , Processed in 0.136877 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表